#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_JuKunPaiHangCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_JuKunPaiHangCFG> Fish_JuKunPaiHangCFG::msSingleton(nullptr);

int Fish_JuKunPaiHangCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JuKunPaiHangCFGData* Fish_JuKunPaiHangCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_JuKunPaiHangCFGData>& Fish_JuKunPaiHangCFG::GetMapData()
{
	return mMapData;
}

void Fish_JuKunPaiHangCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_JuKunPaiHangCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JuKunPaiHangCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mTime = element->IntAttribute("Time");
		data.mStartRank = element->IntAttribute("StartRank");
		data.mEndRank = element->IntAttribute("EndRank");
		{
			const char* Reward = element->Attribute("Reward");
			std::vector<std::string> vecReward;
			boost::split(vecReward, Reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecReward[i].c_str(), &temp))
				{
					data.mReward.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_JuKunPaiHangCFG::Load()
{
	Load("../Config/Fish_JuKunPaiHangCFG.xml");
}

Fish_JuKunPaiHangCFG* Fish_JuKunPaiHangCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JuKunPaiHangCFG());
	}
	return msSingleton.get();
}
